/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.corba.generator;

import java.io.OutputStream;
import org.objectweb.modfact.corba.logging.ModFactLogger;

/**
 * 
 */
public interface Generator {

	/**
	 * Set Input
	 */
	public void setInput(org.omg.mof.Model.ModelElement[] elt) throws Exception;
	
	/**
	 * Set Output
	 */
	public void setOutput(OutputStream stream) throws Exception;
	
	/**
	 * Set Trace
	 */
	public void setLogger(ModFactLogger log) throws Exception;
	
	/**
	 * Generate
	 */
	public void generate() throws Exception;
}
