/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.corba.helper;

import org.omg.CORBA.TypeCodePackage.BadKind;
import org.omg.mof.Model.ModelElement;
import org.omg.mof.Reflective.MofError;
import org.omg.mof.Reflective.NotSet;

/**
 * 
 */
public interface IDLCommon {
	
	
	/**
	 * Format 1
	 */
	public String format1(String input);

	/**
	 * Format 1 (with the first letter in lower case)
	 */
	public String format1FirstMin(String input);

	/**
	 * Format 2
	 */
	public String format2(String input);
	
	/**
	 * Format 3
	 */
	public String format3(String input);
	
	/**
	 * Format 2 - Prevention of IDL conflicts
	 */
    public String format2IdlConflict(String input);
	
	/**
	 * QualfiedName
	 */
	public String qualifiedName(ModelElement modelElement) throws MofError , NotSet;
	
	
	public String className(org.omg.mof.Model.Class clazz)
		throws NotSet, MofError;
	
	/**
	 * 
	 */
	//public String idlPrefix(String idlPrefix);

	/**
	 * return true if the TypeCode represents a base type (i.e. not a struct, enum, alias, sequence
	 */
	public boolean isBaseType(org.omg.CORBA.TypeCode _typecode)
		throws BadKind, org.omg.CORBA.TypeCodePackage.Bounds;
	
}
