/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.corba.service.cmdline.common;

import org.objectweb.util.cmdline.lib.DefaultOptionBase;

/**
 * Class representing the option to display no message.
 */
public class OptionQuiet extends DefaultOptionBase {

	/**
	 * The default constructor.
	 */
	public OptionQuiet() {
		// Calls the DefaultOptionBase constructor.
		super();
		setLabels(new String[] { "-quiet" });
		setDescription(new String[] { "Silent mode." });
		setMandatory(false);
	}

	// ==================================================================
	// Public methods for interface org.objectweb.util.cmdline.api.Option
	// ==================================================================

	/**
	 * Consumes command line arguments from an iterator.
	 * @param iterator The command line argument iterator.
	 */
	public void consume(org.objectweb.util.cmdline.api.Iterator iterator) {
		org.objectweb.modfact.corba.logging.ModFactLogger.setQuiet(true);
	}

}
