/**
 * copyright 2002 2004 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.jmi.api;

import javax.jmi.model.EnumerationType;
import javax.jmi.model.ModelElement;

import org.objectweb.modfact.jmi.generator.BracketGenerator;
import org.objectweb.modfact.jmi.helper.JMIProvider;
import org.objectweb.modfact.jmi.logging.ModFactLogger;


/**
 * @author Xavier
 *
 */
public class EnumerationTypeInterfaceGenerator extends BracketGenerator {

	EnumerationType[] input;

    ModFactLogger logger;

	/**
	 * Set Input
	 */
	public void setInput(ModelElement[] elt) {
		input = new EnumerationType[elt.length];
		for (int i = 0; i < input.length; i++) {
			input[i] = (EnumerationType) elt[i];
		}
	}

	/**
	 * Set Trace
	 */
	public void setLogger(ModFactLogger log) {
		logger = log;
	}

	/**
	 * @see fr.lip6.modfact.generation.Generator#generate()
	 */
	public void generate()  {

		int d = 0;
		EnumerationType type = input[d];

		outputln(
			"package " + JMIProvider.qualifierOf(type) +";" );

		outputln(
			"public interface "
				+ type.getName()
				+ " extends javax.jmi.reflect.RefEnum {}");
		flushFile();
	}

}
