/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.jmi.helper;

import javax.jmi.model.*;

public class ImplHelper {
	
	
  public static final String implPrefix = "org.objectweb.modfact.jmi.repository.";	
	
  public static String wrap(TypedElement t, String code) {
	if(MofHelper.isSinglePrimitive(t)) {
	  String name = t.getType().getName();
	  if(name.equalsIgnoreCase("boolean")) {	  	
		return "new Boolean(" +code +")";
	  } else if(name.equalsIgnoreCase("integer")
	  	|| name.equalsIgnoreCase("long")
	  ) {
		return "new Integer(" +code +")";

	  } else if(name.equalsIgnoreCase("float")) {
		return "new Float(" +code +")"; 	  	
	  } else if(name.equalsIgnoreCase("double")) {
		return "new Double(" +code +")";
	  }
	}
	return code;	  
  }	
  
  public static String unwrap(TypedElement elem, String code) {
  	if(MofHelper.isSinglePrimitive(elem)) {
  	  String name = elem.getType().getName();
  	  if(name.equalsIgnoreCase("boolean")) {	  	
		return "((Boolean)" +code +").booleanValue()";
  	  } else if(name.equalsIgnoreCase("integer")
  	  	|| name.equalsIgnoreCase("long")
  	  ) {
		return "((Integer)" +code +").intValue()";

	  } else if(name.equalsIgnoreCase("float")) {
		return "((Float)" +code +").floatValue()"; 	  	
	  } else if(name.equalsIgnoreCase("double")) {
	  	return "((Double)" +code +").doubleValue()";
  	  }
  	}
  	return code;
  }
	

}
