package org.objectweb.modfact.jmi.ps;

import java.sql.*;

/**
 * @author gregory
 *
 * This class provide utilities for the Service layer of our package
 * (Persistant Service)
 * 
 */
public class PersistantHelper extends PersistantService {

	static Connection connection;

	public PersistantHelper() throws ClassNotFoundException, SQLException {
		Class.forName("com.mysql.jdbc.Driver");
		String url = "jdbc:mysql://localhost:3306/test";
		connection = DriverManager.getConnection(url);

	}

	
	
	/**
	 * Method ifModelExist.
	 * @param name
	 * @return boolean
	 */
	public static boolean ifModelExist(String name) {

		boolean result = false;
		String query =
			"SELECT * FROM modelcontainer where ModelName='" + name + "';";

		try {
			Statement statement = connection.createStatement();
			ResultSet rs = statement.executeQuery(query);

			result = rs.first();
			rs.close();
			statement.close();

		} catch (SQLException e) {
			System.out.println(e.toString());
			e.printStackTrace();
		}

		return result;

	}

	
	
	/**
	 * Method getModelIdbyName.
	 * @param name
	 * @return String
	 */
	public static String getModelIdbyName(String name) {

		String id = null;
		String query =
			"SELECT ModelContainerID FROM modelcontainer where ModelName='"
				+ name
				+ "';";

		try {
			Statement statement = connection.createStatement();
			ResultSet rs = statement.executeQuery(query);
			rs.next();
			id = rs.getString("ModelContainerId");
			rs.close();
			statement.close();

		} catch (SQLException e) {
			System.out.println(e.toString());
			e.printStackTrace();
		}

		return id;
	}

	/**
	 * Method createMetamodel.
	 * @param name
	 */
	public static void createMetamodel(String name) {

		String query =
			"INSERT INTO ModelContainer (ModelName) VALUES ('" + name + "');";
		try {
			Statement statement = connection.createStatement();
			statement.execute(query);

			statement.close();

		} catch (SQLException e) {
			System.out.println(e.toString());
			e.printStackTrace();
		}
	}

	/**
	 * Method deleteMetamodelContent.
	 * @param name
	 * delete only the content of a metamodel and not the name entry in the
	 * database
	 */
	public static void deleteMetamodelContent(String name) {

		String modelId = getModelIdbyName(name);
		String query =
			"DELETE FROM RefPackage WHERE ModelContainerId = '"
				+ modelId
				+ "';";
		try {
			Statement statement = connection.createStatement();
			statement.execute(query);
			statement.close();

		} catch (SQLException e) {
			System.out.println(e.toString());
			e.printStackTrace();
		}
	}

	/**
	 * Method printFreeMemory.
	 * @param message
	 * usefull for testing memory load : to be improved; i.e 
	 * be more accurate and use a logger instead of System.out as 
	 * outputstreamn
	 */
	public static void printFreeMemory(String message) {

		System.out.println(
			"Free Memory "
				+ message
				+ ":->"
				+ Runtime.getRuntime().freeMemory());
	}

}
