package org.objectweb.modfact.jmi.ps;

import javax.jmi.reflect.*;

import org.objectweb.modfact.jmi.helper.StringHelper;

import java.sql.*;

/**
 * @author gregory
 *
 * This class is a wrapper for accessing the database for create and update
 * operations
 */

public class Writer {

	Connection connection;
	MOFPolymorphicIterator mofIt;
	MOFPolymorphicIterator mofModelIt;
	RefPackage mofModel;

	public Writer(RefPackage p)
		throws ClassNotFoundException, SQLException {

		Class.forName("com.mysql.jdbc.Driver");
		String url = "jdbc:mysql://localhost:3306/test";
		connection = DriverManager.getConnection(url);

		mofIt = new MOFPolymorphicIterator(p);

		
	}

	/**
	 * Method create.
	 * @param o
	 * @param modelId
	 * @return String
	 */
	public String create(RefObject o,String modelId) {
		String query =
			"INSERT INTO RefPackage (RefPackageID,ModelContainerID) VALUES ('"
				+  StringHelper.replaceAll(o.refMofId(), ",", "*")
				+ "','"+ modelId +"');";
		try {
			Statement statement = connection.createStatement();
			statement.execute(query);
			statement.close();
			return StringHelper.replaceAll(o.refMofId(), ",", "*");

		} catch (Exception e) {
			e.printStackTrace();
		}

		return StringHelper.replaceAll(o.refMofId(), ",", "*");
	}

	/**
	 * Method rename.
	 * @param p
	 * @param elementId
	 */
	public void rename(RefObject p, String elementId) {
		String listOfPackages = null;
		String listOfClasses = null;
		String listOfAssociations = null;

		//get the immediate pacakge
		String immediatePackage;
		if (p.refImmediatePackage() == null)
			immediatePackage = "null";
		else
			immediatePackage =
                StringHelper.replaceAll(p.refImmediatePackage().refMofId(), ",", "*");

		//get the container
		String container;
		RefObject refContainer = (RefObject) p.refGetValue("container");
		//container =p.refMetaObject().refGetValue("container").toString();
		if (refContainer == null)
			container = "null";
		else
			container = StringHelper.replaceAll(refContainer.refMofId(), ",", "*");

		String query =
			"UPDATE RefPackage SET Name='"
				+ (p).refGetValue("name")
				+ "', annotation ='"
			//+"annotation"
	+p.refGetValue("annotation")
		+ "',qualifiedName='"
		+ StringHelper.replaceAll(p.refGetValue("qualifiedName").toString(), ",", "#")
		+ "',container='"
		+ container
		+ "',constraints='"
		+ p.refMetaObject().refGetValue("constraints");

		if (p.refMetaObject().refGetValue("name").equals("Package")) {
			query =
				query
					+ "',visibility='"
					+ p.refGetValue("visibility")
					+ "',isLeaf='"
					+ p.refGetValue("isLeaf")
					+ "',isRoot='"
					+ p.refGetValue("isRoot")
					+ "',isAbstract='"
					+ p.refGetValue("isAbstract")
					+ "',supertypes='"
					+ p.refGetValue("supertypes")
					+ "',refMetaObject='"
					+ StringHelper.replaceAll(p.refMofId(), ",", "*")
					+ "',type='RefPackage";
		} else if (p.refMetaObject().refGetValue("name").equals("Class")) {
			query =
				query
					+ "',visibility='"
					+ p.refGetValue("visibility")
					+ "',isLeaf='"
					+ p.refGetValue("isLeaf")
					+ "',isRoot='"
					+ p.refGetValue("isRoot")
					+ "',isAbstract='"
					+ p.refGetValue("isAbstract")
					+ "',supertypes='"
					+ p.refGetValue("supertypes")
					+ "',refMetaObject='"
					+ StringHelper.replaceAll(p.refMofId(), ",", "*")
					+ "',isSingleton='"
					+ p.refGetValue("isSingleton")
					+ "',type='RefClass";

		} else if (
			p.refMetaObject().refGetValue("name").equals("Association")) {
			query =
				query
					+ "',visibility='"
					+ p.refGetValue("visibility")
					+ "',isLeaf='"
					+ p.refGetValue("isLeaf")
					+ "',isRoot='"
					+ p.refGetValue("isRoot")
					+ "',isAbstract='"
					+ p.refGetValue("isAbstract")
					+ "',supertypes='"
					+ p.refGetValue("supertypes")
					+ "',refMetaObject='"
					+ StringHelper.replaceAll(p.refMofId(), ",", "*")
					+ "',isDerived='"
					+ p.refGetValue("isDerived")
					+ "',type='RefAssociation";

		}

		//if p is an associationEnd
		else if (
			p.refMetaObject().refGetValue("name").equals("AssociationEnd")) {

			query =
				query
					+ "',isNavigable='"
					+ p.refGetValue("isNavigable")
					+ "',aggregation='"
					+ p.refGetValue("aggregation")
					+ "',multiplicity='"
					+ p.refGetValue("multiplicity")
					+ "',isChangeable='"
					+ p.refGetValue("isChangeable")
					+ "',type='RefAssociationEnd";
		}

		//if p is an Attribute
		else if (p.refMetaObject().refGetValue("name").equals("Attribute")) {

			query =
				query
					+ "',isChangeable='"
					+ p.refGetValue("isChangeable")
					+ "',visibility='"
					+ p.refGetValue("visibility")
					+ "',scope='"
					+ p.refGetValue("scope")
					+ "',isDerived='"
					+ p.refGetValue("isDerived")
					+ "',type='RefAttribute";
		}

		//if p is a Reference
		else if (p.refMetaObject().refGetValue("name").equals("Reference")) {

			query =
				query
					+ "',isChangeable='"
					+ p.refGetValue("isChangeable")
					+ "',visibility='"
					+ p.refGetValue("visibility")
					+ "',scope='"
					+ p.refGetValue("scope")
					+ "',referencedEnd='"
					+ StringHelper.replaceAll(((RefObject)p.refGetValue("referencedEnd")).refMofId(), ",","*")
//					+ "',exposedEnd='"
//					+ ((RefObject)p.refGetValue("exposedEnd")).refMofId().replaceAll(",","*")
					+ "',type='RefReference";
		}
		//		if p is a Tag
		else if (p.refMetaObject().refGetValue("name").equals("Tag")) {

			query =
				query
					+ "',tagId='"
					+ p.refGetValue("tagId")
					+ "',tagvalues='"
					+ p.refGetValue("values")
					+ "',taggedElements='"
					+ p.refGetValue("elements")
					+ "',type='RefTag";
		}
		
		//miss if p is a opration
		
		
		query = query + "' WHERE RefPackageID=" + elementId + ";";

		//,RefPackageContainer,RefMetaObject,RefPackageList,RefClassList,RefAssociationList) VALUES ("

		try {
			Statement statement = connection.createStatement();

			//System.out.println(query);
			statement.execute(query);
			statement.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
