package org.objectweb.modfact.jmi.reflect;

import java.util.*;
import javax.jmi.reflect.*;

public abstract class DataTypeContainer extends RefBaseObjectImpl {
	
	List structNames = new Vector();
	List[] structQNames = null;;
	List[] structFieldNameLists = null; 
    
	List enumTypeNames = new Vector();
	Object[] enumTypes = null;
	
	void readDataTypeContents() {

		List structList = new Vector();
		List enumList = new Vector();
		
		Iterator it = ((Collection)metaObject.refGetValue("contents")).iterator();
		
		while(it.hasNext()) {
			RefObject content = (RefObject)it.next();
			String contentName = (String) content.refGetValue("name");
			String contentType = (String) content.refMetaObject().refGetValue("name");			

			if(contentType.equals("StructureType")) {
				structNames.add(contentName);
				List fieldNames = new Vector();
				Iterator it2 = ((Collection) content.refGetValue("contents")).iterator();
				while(it2.hasNext()) {
					RefObject cc = (RefObject)it2.next();
					String ccType = (String) cc.refMetaObject().refGetValue("name");
					if(ccType.equals("StructureField")) {
						fieldNames.add(cc.refGetValue("name"));
						// System.out.println("Structure field: " + cc.refGetValue("name"));
					}
				}
				structList.add(fieldNames);
                
			} else if(contentType.equals("EnumerationType")) {
				enumTypeNames.add(contentName);
				List labels = (List) content.refGetValue("labels");
				Object m = newEnum(contentName);
				List typeName = this.refTypeName(); //qualified container name
				typeName.add(contentName); //qualified type name	
				if(m==null) {			
				  m = new EnumType(typeName,labels);
				}
				enumList.add( m );
			}	
		}
		structFieldNameLists = (List[]) structList.toArray(new List[0]);
		enumTypes = (Object[]) enumList.toArray(new Object[0]);
		
	}
   
	public RefStruct refCreateStruct(javax.jmi.reflect.RefObject refObject, java.util.List list) {
		String name = (String) refObject.refGetValue("name");
		return refCreateStruct(name, list);
	}
    
	public RefStruct refCreateStruct(String type, java.util.List list) {
		int index = structNames.indexOf(type);
		if(index==-1) {
			throw new RuntimeException("Illegal struct type: " +type);
		}
		if(structQNames==null) {
		  List containerQName = refTypeName();
		  structQNames = new List[structNames.size()]; 
		  for(int i=0; i<structQNames.length; i++) {
			List l = new Vector(containerQName);
			l.add(structNames.get(i));
			structQNames[i] = l;
		  }
		}
		
		RefStructImpl s = newStruct(type);
		s.typeNames = structQNames[index];
		s.fieldNames = structFieldNameLists[index];
		s.setValues(list);
		return s;
	}
    
	public RefEnum refGetEnum(javax.jmi.reflect.RefObject refObject, String val) {
		String type = (String) refObject.refGetValue("name");
		return refGetEnum(type, val);
	}
    
	public RefEnum refGetEnum(String type, String val) {
		int index = enumTypeNames.indexOf(type);
		if(index==-1) {
			throw new RuntimeException("Invalide Enum type: " +type);
		}
		if(enumTypes[index] instanceof EnumType)
			return ((EnumType)enumTypes[index]).getEnum(val);
		Class[] argType = { String.class };
		Object[] args = { val };
		try {
		  return (RefEnum) ((Class)enumTypes[index])
			.getMethod("forName", argType)
			.invoke(
			null, args
		  );
		} catch(Exception e) {
		  System.out.println("error at " +enumTypes[index]);	
		  throw new RuntimeException(e);
		}
	}
    
	/////////////// to be over writen ////////////////    
	public Class newEnum(String name) {
      return null;
	}
    
	public RefStructImpl newStruct(String name) {
      return new RefStructImpl();
	}

}
