package org.objectweb.modfact.jmi.reflect;

import javax.jmi.reflect.*;
import java.util.*;

public class RefAssociationImpl extends RefBaseObjectImpl implements RefAssociation, java.io.Serializable {
    
    String firstEndName;
    String secondEndName;
    String type1;
    String type2;
    boolean isEnd1Ordered;
    boolean isEnd2Ordered;
    
    Hashtable table_2_1 = new Hashtable(); // second end (key)-> first ends (Collection)
    Hashtable table_1_2 = new Hashtable();  // first end (key)-> second ends (Collection)
    
    public RefAssociationImpl() {
    }
    
    
    public boolean refAddLink(javax.jmi.reflect.RefObject first, javax.jmi.reflect.RefObject second) {
        if(!container.canModify) {
            throw new RuntimeException("Not allowed to modify");
        }
        return _refAddLink(first ,second);    
    }    
    
    boolean _refAddLink(javax.jmi.reflect.RefObject first, javax.jmi.reflect.RefObject second) {
        doSync();
        Collection firstSet = (Collection) table_2_1.get(second);
        Collection secondSet = (Collection) table_1_2.get(first);
        if (firstSet!=null && firstSet.contains(first) )  return false;
        if(firstSet==null) {
          firstSet = new Vector();
          table_2_1.put(second ,firstSet);
        }
        if(secondSet==null) {
          secondSet = new Vector();
          table_1_2.put(first ,secondSet);
        }
        firstSet.add(first);
        secondSet.add(second);
        return true;
    }
    
    public java.util.Collection refAllLinks() {
        doSync();        
        Collection r = new Vector();
        
        if(isEnd2Ordered) {
          // System.out.println("Association '" +name +"' end2 '" +secondEndName +"' is ordered");
          Iterator it = table_1_2.keySet().iterator();
          while(it.hasNext()) {
            RefObject first = (RefObject) it.next();  
            Iterator it2 = ((Collection)table_1_2.get(first)).iterator();
            while(it2.hasNext()) {
              RefObject second = (RefObject) it2.next();  
              r.add(new RefAssociationLinkImpl(first,second));
            }          
          }           
        } else {
          
          //if(isEnd1Ordered) System.out.println("Association '" +name +"' end1 '" +firstEndName +"' is ordered");
          //else System.out.println("Association '" +name +"' is NOT ordered");
          
          Iterator it = table_2_1.keySet().iterator();
          while(it.hasNext()) {
            RefObject second = (RefObject) it.next();  
            Iterator it2 = ((Collection)table_2_1.get(second)).iterator();
            while(it2.hasNext()) {
              RefObject first = (RefObject) it2.next();  
              r.add(new RefAssociationLinkImpl(first,second));
            }          
          }
        }
        return r;
    }
    
    public boolean refLinkExists(javax.jmi.reflect.RefObject first, javax.jmi.reflect.RefObject second) {
        doSync();
        Collection firstSet = (Collection) table_2_1.get(second);
        if (firstSet==null) return false;
        return firstSet.contains(first);
    }
    
    public java.util.Collection refQuery(String endName, javax.jmi.reflect.RefObject endObj) {
        doSync();
        if(endName.equals(firstEndName)) {
            return new AssoEndList(this, endObj, true );
        } 
        if(endName.equals(secondEndName)) {
            return new AssoEndList(this, endObj, false);
        }
        throw new RuntimeException("refQuery " +name +"(" +firstEndName +"," +secondEndName +"):Invalide name: " +endName);
    }
    
    public java.util.Collection refQuery(javax.jmi.reflect.RefObject meta, javax.jmi.reflect.RefObject endObj) {
        return refQuery( (String)meta.refGetValue("name") ,endObj );
    }
    
    public boolean refRemoveLink(javax.jmi.reflect.RefObject first, javax.jmi.reflect.RefObject second) {
        if(!container.canModify) {
            throw new RuntimeException("Not allowed to modify");
        }
        doSync();
        Collection firstSet = (Collection) table_2_1.get(second);
        Collection secondSet = (Collection) table_1_2.get(first);
        if (firstSet==null)  return false;
        firstSet.remove(first);
        return secondSet.remove(second);
    }

    public javax.jmi.reflect.RefObject refMetaObject() {    
        if(metaObject!=null) return metaObject;
        return findObjectByName( container.refClass("Association"), name);
    }
    
    // this method is used to save the storage space 
    // One table can be derived from the other
    // "isOrdered" table must be persistent!
    void doSync() {
    }
    
    /*
    // create TableB from TableA;    
    // for every key a in A, find {b1, b2, ..., bn}
    // for bi 
    //      B.get(bi).add(a)
    {      
        tableB = new Hashtable();
        Iterator it = tableA.keySet().iterator();
        while(it.hasNext()) {
          RefObject a = (RefObject) it.next();  
          Iterator it2 = ((List)A.get(a)).iterator();
          while(it2.hasNext()) {
            RefObject bi = (RefObject) it2.next();  
            List l = (List) B.get(bi);
            if(l==null) {
               l = new Vector();
               B.put(bi, l);
            }
            l.add(a);            
          }          
        } 
    */
    
    String getOtherEndName(String end) {
        return (firstEndName.equals(end))? secondEndName: 
                  (secondEndName.equals(end))? firstEndName: null; 
    }
    
}
