/**
 * copyright 2002 2004 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.jmi.service;


public class GenerationService
	extends org.objectweb.modfact.jmi.service.cmdline.xmiio.ImportApplication {

    /** The API Zip file. */
    private String apiFile = null;

    /** The Impl Zip file. */
    private String implFile = null;

    /** The XMI Import Zip file. */
    private String importFile = null;

    /** The XMI Export Zip file. */
    private String exportFile = null;


    /**
     * Constructor of a GenerationService.
     */
    public GenerationService() {
        super(
            new org.objectweb.util.cmdline.lib.DefaultCommandLine(
                new String[] { "GenerationService" },
                new String[0],
                new String[] { "Tool to manage the MOF Repository" },
                true));
        // Creates the GenerationService options
        getCommandLine().addOption(
            new org.objectweb.modfact.jmi.service.cmdline.client.OptionApi(this));
        getCommandLine().addOption(
            new org.objectweb.modfact.jmi.service.cmdline.client.OptionImpl(this));
        getCommandLine().addOption(
            new org.objectweb.modfact.jmi.service.cmdline.client.OptionImport(this));
        getCommandLine().addOption(
            new org.objectweb.modfact.jmi.service.cmdline.client.OptionExport(this));
    }

    /**
     * Starts the main function.
     * 
     * @param args
     *            The command line arguments.
     */
    public int start(String[] args) {
        try {
            Generation client = new Generation();
            client.execute(metaModelFile, apiFile, implFile, importFile, exportFile);
            return 0;
        } catch (Exception ex) {
            report_exception(ex);
            return -1;
        }
    }

    /**
     * The main method.
     * 
     * @param args
     *            The command line arguments.
     */
    public static void main(String[] args) {
        GenerationService application = new GenerationService();
        application.runMain(args);
    }
        

    /**
     * Sets the apiFile.
     * @param apiFile The apiFile to set
     */
    public void setApiFile(String apiFile) {
        this.apiFile = apiFile;
    }

    /**
     * Sets the exportFile.
     * @param exportFile The exportFile to set
     */
    public void setExportFile(String exportFile) {
        this.exportFile = exportFile;
    }

    /**
     * Sets the implFile.
     * @param implFile The implFile to set
     */
    public void setImplFile(String implFile) {
        this.implFile = implFile;
    }

    /**
     * Sets the importFile.
     * @param importFile The importFile to set
     */
    public void setImportFile(String importFile) {
        this.importFile = importFile;
    }

}


