/**
 * copyright 2002 2004 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.jmi.service.cmdline.common;

/**
 * Class represnting a modfact base application, which can be an importer or an exporter.
 */
public abstract class ModfactApplicationBase extends org.objectweb.util.cmdline.lib.ApplicationBase {
    
    /**
     * Constructor of a ModfactApplicationBase (call to the super class constructor).
     * @param commandLine The command line manager.
     */
    protected ModfactApplicationBase(org.objectweb.util.cmdline.lib.DefaultCommandLine commandLine) {
        super(commandLine, true);
        getCommandLine().addOption(new OptionQuiet(this));
    }

    /**
     * Obtains the mailing list associated to this development.
     * @return The mailing list associated to this development.
     */
    public String getMailingList() {
        return "modfact@lip6.fr";
    }

    /**
     * Obtains the associated version information.
     *
     * @return The associated version information.
     */
    public String[] getVersionInformation() {
        return new String[] {
            getIdentity(),
            "",
            "Copyright (C) 2000-2004 Laboratoire d'Informatique Paris 6 (LIP6)",
            "Contact: " + getMailingList(),
            "",
            "ModFact is free software; you can redistribute it and/or",
            "modify it under the terms of the GNU Lesser General Public",
            "License as published by the Free Software Foundation; either",
            "version 2 of the License, or any later version.",
            "",
            "ModFact is distributed in the hope that it will be useful,",
            "but WITHOUT ANY WARRANTY; without even the implied warranty of",
            "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU",
            "Lesser General Public License for more details.",
            "",
            "You should have received a copy of the GNU Lesser General Public",
            "License along with this library; if not, write to the Free Software",
            "Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA" };
    }

}
