//****************************************************************************************
// Parseur SimpleTRL=>XMI V1.0 Beta.  25/10/2003									     *
// Auteur : BENDRAOU REDA      Reda.Bendraou@Lip6.fr  									 *
// Org	   : LIP6  //www.lip6.fr                										 * 
// Thme  : SRC/Engenierie des Modles													 *		
// Equipe : Marie-Pierre.Gervais@lip6.fr, Xavier.Blanc@lip6.fr, Salim.Bouzitouna@lip6.fr,* 
//          prawee_th@yahoo.com, gregory@easyplanet.net                                  *
// Projet : ModFact                             										 *														
//****************************************************************************************


{import java.util.*;
import java.util.logging.Logger;}
class STRLParser extends Parser;
options { k=3;} // Permet de grer l'indeterminisme : le lookahead
		 

//******VARIABLES GLOBALES*********************************************************************************************************************************
{Vector ValAssExpVec, RuleElemVec; 	// Vecteur contenant tous les lments d'un Statement																  *	
Vector ifVect=new Vector();       	// Vecteur pour grer l'imbrication des IfStatement																	  *
Vector ifElse=new Vector();	  	// Vecteur pour grer l'imbrication des Statements si dans le block if/else                                           *
Hashtable RulesTab;				  	// Une Table de Hash pour recenser toutes le rgles et viter d'en crer deux fois la mme rgle; Key=nom de la rgle *
String CurrentRule=null;			// Permet de savoir la rgle courante au moment de rajouter le Statement											  *	
simpletrl.RulesUnit unit;			   // Permet de rajouter une rgle  Rules Unit n'importe o dans le programme										  *
simpletrl.PropertyAssignExp pAssExp;   // manipule par plusieurs blocks																				  *
simpletrl.IfStatementExp iFSE;		   // manipule par plusieurs blocks 																				  *
simpletrl.SimpleTRLPackage rulesModel; // Le modle simpleTRL en question																				  *	
private Logger logger;				   // Pour la Trace															  										  *
//*LES METHODES GET & SET LOGGER POUR LA TRACE*************************************************************************************************************

public void setRuleModel(simpletrl.SimpleTRLPackage rulesModel) {
		this.rulesModel = rulesModel;
	}

public Logger getLogger() {
		return logger;
	}

public void setLogger(Logger logger) {
		this.logger = logger;
	}	
}
//**********************************************************************************************************************************************************

file			     // Rgle qui reconnat une Rules Unit
					 {logger.fine("File Rule Called");
					  RulesTab=new Hashtable();
					 }
					 :("RulesUnit" (WS)+ n:NAME (WS)+ SOURCE (WS)+ s:NAME (WS)+ TARGET (WS)+ t:NAME (WS)+ OPENBRACKET (NEWLINE)? 
					 {unit = rulesModel.getRulesUnit().createRulesUnit(n.getText(),s.getText(),t.getText());} 
					 //Une Rules Unit est compose de plusieurs rgles 
					 (WS)* (rule NEWLINE)+ 
					 CLOSEBRACKET (NEWLINE)?)
					 // Traces
				 	 {logger.fine("name =" + n.getText());
				 	 logger.fine("Source =" + s.getText());
				 	 logger.fine("Target =" + t.getText());
				 	 logger.fine("Recognition Succed");
				 	 }		  
					 ;	
					 
rule				 // Une rgle peut tre soit une EntryPointRule, soit une CalledRule
					 :(erp|cr)
					 {logger.fine("rule");}	
					 ;
					 
erp					 // La rgle EntryPointRule
					 {String resultElement=null; simpletrl.EntryPointRule epr;}
					 :("EntryPointRule" (WS)+ n:NAME NEWLINE (WS)* 
					 "context" (WS)+ elementcontext:NAME NEWLINE 
					 (resultElement=createclose)?  
					 
					 {logger.fine("EntryPointRule Called");			 
					 epr = rulesModel.getEntryPointRule().createEntryPointRule(n.getText(),"","",elementcontext.getText());
					 
					 // Correspond  l'attribut resultType dans le MM SimpleTRL 
					 if (resultElement!=null)
						 epr.setResultType(resultElement);
					 else
					     epr.setResultType("");
					 // La fixer comme la rgle courante
					 CurrentRule=n.getText();
					 // Rajouter la rgle dans tables des rgles
					 RulesTab.put(n.getText(),epr);
					 }
					 // Une rgle peut avoir ou pas, un corp
					 (WS)* (body)?)
					 ;	 
					 
cr					 // La rgle Called Rule
					 {simpletrl.CalledRule cr=null; simpletrl.ValueExp vExp=null; 
					  String resultElement=null; java.util.Vector Parameters=new java.util.Vector(); boolean exist=true;
					 }
					 :("Rule" (WS)+ n:NAME (Parameters=signRule) 
					 {exist=(RulesTab.containsKey(n.getText()));
					  CurrentRule=n.getText(); 
					 }  
					  NEWLINE (WS)*
					  // Correspond  l'attribut resultType dans le MM SimpleTRL 
					  (resultElement=createclose)? 
					  // Correspond  l'association HasReturnVal 
					  (vExp=returnclose)?
					 {logger.fine("CalledRule  Called");

					 //Vrifier si la rgle n'existe pas dj
					 if (!(exist)){
					 	cr=rulesModel.getCalledRule().createCalledRule();
					 	cr.setName(n.getText());
					 	
					 	if (resultElement!=null)
							 cr.setResultType(resultElement);
					 	else
					    	 cr.setResultType("");
					 	// Fixation des paramtres de la rgle
					 	for (int i=0; i<Parameters.size(); i++){
					    	 simpletrl.ParameterExp Param=rulesModel.getParameterExp().createParameterExp(((simpletrl.ParameterExp)Parameters.elementAt(i)).getName());
					   	 	 cr.getParams().add(Param);
					   	} 
					   	
					   	if (vExp!=null)
					   		cr.setReturnVal(vExp);

					   	RulesTab.put(cr.getName(),cr);
					
					 }
					 else{
					 	cr=((simpletrl.CalledRule)RulesTab.get(n.getText()));
					 	
					 	if (resultElement!=null)
							 cr.setResultType(resultElement);
					 	else
					    	 cr.setResultType("");
					 
					 	for (int i=0; i<Parameters.size(); i++){
					    	 simpletrl.ParameterExp Param=rulesModel.getParameterExp().createParameterExp(((simpletrl.ParameterExp)Parameters.elementAt(i)).getName());
					   	 	 cr.getParams().add(Param);
					   	}
					 	if (vExp!=null)
					   		cr.setReturnVal(vExp);
					 	
					 }
					 
					 logger.fine("CR Position, la Rgle courante est :" + CurrentRule);	 			 
					 }
					 (body)?)	
					 ;
					 
body 	 			 // Correspond  l'association HasBody du MM SimpleTRL. 
					 :OPENCROCHET (NEWLINE)?(WS)*
					 // Une rgle a un corp qui contient 0 ou n Statement
					 (statementExp)* 
					 CLOSECROCHET 
					 // Rajouter la rgle  Rules Unit
					 {unit.getRules().add((simpletrl.Rule)RulesTab.get(CurrentRule));}
					 ;					 

					 // La signature d'une rgle
signRule returns[java.util.Vector Parameters=new java.util.Vector()]			 
					 :(OPENPARENT (Parameters=params)? CLOSEPARENT)					 
					 ;
					 
					 // Les paramtres d'une rgle
params returns[java.util.Vector Parameters=new java.util.Vector()]
					 {simpletrl.ParameterExp p=rulesModel.getParameterExp().createParameterExp();}
					 :((WS)* p=parameterExp (WS)* {Parameters.addElement(p);} (COMMA (WS)* p=parameterExp {Parameters.addElement(p);})*)
					 ;
					 
					 // L'lment ParameterExp du MM SimpleTRL
parameterExp returns[simpletrl.ParameterExp ParamExp=rulesModel.getParameterExp().createParameterExp()]    	 
					 :(DIEZ n:NAME {ParamExp.setName(n.getText());}
					 // Les paramtres par dfaut : #context et #result
					 |DIEZ c:"context"{ParamExp.setName(c.getText());}
					 |DIEZ r:"result"{ParamExp.setName(r.getText());})					 
					 {RuleElemVec.addElement(ParamExp);}
					 ;
					 
					 // Correspond  l'attribut resultType dans le MM SimpleTRL 
createclose	returns[String resultElement= new String()] 
					 :"creates" (WS)+ n:NAME NEWLINE
					 {resultElement=n.getText();}
					 ;	
					 
					 // Correspond  l'association HasReturnVal dans le MM SimpleTRL 	
returnclose returns[simpletrl.ValueExp vExp=null]
			     	 :"return" (WS)+ (vExp=valueExp)+ NEWLINE
					 ;
					 
					 // Correspond  l'lment StatementExp du MM SimpleTRL
statementExp		 {logger.fine("je suis dans Statement");
					  RuleElemVec=new Vector();
					  simpletrl.RuleCallExp rCE;
					  simpletrl.CollectionExp CE;
					  simpletrl.IfStatementExp ifs;
					 }
					 // Un StatementExp peut tre soit un AbstractOperationCallExp, un CollectionExp, PropertyAssignExp ou bien un IfStatementExp
					 // Dans AbstractOperationCallExp, nous avons considrer juste Rule CallExp. OperationCallExp n'tant partiquement jamais utilise
					 
					 // Toujours vrifier d'abord si le statement identifi n'est pas imbriqu dans un IfStatement. 
					 //Cela permet de crer la rference du contenu vers le conteneur
					 
					 :(((context  // Tout StatementExp est prced d'un Context qui est un lment ValueExp. cf. la rgle context
					 
					 ((rCE=ruleCallExp) {
						 
						 if (ifElse.isEmpty())	
						 	((simpletrl.Rule)RulesTab.get(CurrentRule)).getStatements().add(rCE);
						 else	{
						 	if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==1){
						 		iFSE.getThenStatements().add(rCE);
						 	}	
						 	if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==0){
						 		iFSE.getElseStatements().add(rCE);
						 	}
						 }
						 	
					 	}
					 	|propertyAssignExp value {
					 		
					 		if (ifElse.isEmpty()) {	
						 	((simpletrl.Rule)RulesTab.get(CurrentRule)).getStatements().add(pAssExp);
					 		}
						    else	{
					 		if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==1){
						 		iFSE.getThenStatements().add(pAssExp);
						 	}	
						 	if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==0){
						 		iFSE.getElseStatements().add(pAssExp);
						 	}
						 }

					 	}
					 	|(CE=collectionExp) {
					 		
					 		if (ifElse.isEmpty())	
						 	((simpletrl.Rule)RulesTab.get(CurrentRule)).getStatements().add(CE);
						    else	{
					 		if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==1){
						 		iFSE.getThenStatements().add(CE);
						 	}	
						 	if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==0){
						 		iFSE.getElseStatements().add(CE);
						 	}
						 }
					 		 
					 	}
					 	
					 	))
					 	|(ifs=ifStatementExp) {
					 		if (ifVect.size()==1){				 								 			
					 			((simpletrl.Rule)RulesTab.get(CurrentRule)).getStatements().add(ifs);
					 			ifElse.clear();
					 			ifVect.clear();
					 		}
					 	
					 		if (ifVect.size()>=2){
					 			
					 			ifElse.removeElementAt(ifElse.size()-1);
					 			ifElse.removeElementAt(ifElse.size()-1);
					 			
					 			if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==0){					 				 
					 		   		((simpletrl.IfStatementExp)ifVect.elementAt(ifVect.size()-2)).getElseStatements().add(ifs);
					 			}
					 		    else {
					 		    	 ((simpletrl.IfStatementExp)ifVect.elementAt(ifVect.size()-2)).getThenStatements().add(ifs);
					 		    }
					 		   
								ifVect.removeElementAt(ifVect.size()-1);
								iFSE=((simpletrl.IfStatementExp)ifVect.elementAt(ifVect.size()-1));					 		  				 		  	
					 		  }					 								 		
					 		
					 		}
					 		
					 		) 
					 	// Reinitialiser le Vecteur qui contient les lment d'un Statement
					 	{RuleElemVec.removeAllElements();}  
					 	 NEWLINE (WS)*)
					 ;	

					 // Correspond  l'assiation HasContext
context				 :(valueExp)* 
					 // vu que certains lments hritent en mme temps de ValueExp, de ContextExp et de StatementExp 
					 // et afin d'viter toute ambiguit, nous avons rajouter le caractre '!' pour dlimter le context du statement en question
					 POINTEXCLAM 
					 ;	
					 
					 //  Correspond  l'lment ValueExp du MM SimpleTRL dont hritent 10 lments (qui hritent aussi de StatementExp et de ContextExp	
valueExp returns [simpletrl.ValueExp ValExp=null]			 
					 :((ValExp=parameterExp)|(ValExp=modelReferenceExp)|(ValExp=propretyCallExp)
					 |(ValExp=isOfTypeExp)|(ValExp=compareExp)|(ValExp=ifValueExp)|(ValExp=literalExp)
					 |(ValExp=ruleCallExp)|(ValExp=collectionExp)|propertyAssignExp
					 |POINT)  // nous avons rajouter le '.' juste pour cte partique de la chose
				 	 ;	

		     		 // Correspond  l'lment ModelReferenceExp du MM SimpleTRL
modelReferenceExp returns [simpletrl.ModelReferenceExp mRef=rulesModel.getModelReferenceExp().createModelReferenceExp()]
				     {logger.fine("je suis dans modelReferenceExp");}
					 :("allOfType" OPENPARENT (WS)* n:NAME (WS)* CLOSEPARENT)
					 {mRef.setConceptName(n.getText());
					  RuleElemVec.addElement(mRef);
					 }
		     	 	 ;
		     	 	 
		     	 	 // Correspond  l'lment RuleCallExp du MM SimpleTRL     
ruleCallExp returns [simpletrl.RuleCallExp rCall = rulesModel.getRuleCallExp().createRuleCallExp()]	    	 
					 {logger.fine("je suis dans ruleCallExp");
					  simpletrl.ValueExp vExp1=null; 
					  simpletrl.ValueExp vExp2=null;
					  Vector paramVec=new Vector();
					  boolean exist;
					  }
					 :(n:NAME OPENPARENT 
					  // Fixer le context, du fait qu'il hrite de ContextExp et donc il a un context
					  {rCall.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));} 
					  ((WS)* (vExp1=valueExp)* {if (vExp1!=null) paramVec.addElement(vExp1);} 
					  (COMMA (WS)* (vExp2=valueExp)* {if (vExp2!=null) paramVec.addElement(vExp2);})*) CLOSEPARENT)
					  // Vrifier si la rgle existe dj sinon la crer
					  { exist=(RulesTab.containsKey(n.getText()));
					  	if (!exist){
					  	    simpletrl.CalledRule cr=rulesModel.getCalledRule().createCalledRule(n.getText(),"","");
					  	    RulesTab.put(cr.getName(), cr);
					  	    logger.fine("je suis dans ruleCallExp et le nom de la rgle rajoute est =" + cr.getName()); 
					  	    rCall.setRule(cr);
		       	        		       	        	
					  	}
					  	else {
					  		rCall.setRule((simpletrl.CalledRule)RulesTab.get(n.getText()));		       	        						  		
					  	}
		       	        
		       	        // Correspond  l'association hasArgs du MM 
		       	        for (int i=0; i<paramVec.size(); i++){
		       	        	rCall.getArgs().add((simpletrl.ValueExp)paramVec.elementAt(i));
		       	        }
		       	        
		       	        RuleElemVec.addElement(rCall);
					  }
		     		 ;
		     		 
		     		 // Correspond  l'lment CollectionExp du MM SimpleTRL     
collectionExp returns[simpletrl.CollectionExp cE=null]
					 // Un lement CollectionExp peut tre soit un AddCollectionExp, soit un RemoveCollectionExp
			         :((cE=addCollectionExp)|(cE=removeCollectionExp))
		     	     ;	
		     	     
		     	     // Correspond  l'lment AddCollectionExp qui hrite de CollectionExp du MM SimpleTRL
addCollectionExp returns[simpletrl.AddCollectionExp aCE=rulesModel.getAddCollectionExp().createAddCollectionExp()] 
					 {simpletrl.ValueExp member=null;}     
					 :("add" OPENPARENT (WS)*
					 {aCE.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));}
					 (member=valueExp)+ (WS)* CLOSEPARENT)
					 // Correspond  l'association hasMember du MM
					 {aCE.setMember(member);	
					  RuleElemVec.addElement(aCE);	
					 }
			     	 ;	
			     	 
			     	 // Correspond  l'lment RemoveCollectionExpqui hrite de CollectionExp du MM SimpleTRL	     
removeCollectionExp returns[simpletrl.RemoveCollectionExp rCE=rulesModel.getRemoveCollectionExp().createRemoveCollectionExp()] 
					 {simpletrl.ValueExp member=null;} 
					 :("remove" OPENPARENT (WS)*
					 {rCE.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));}
					 (member=valueExp)+ (WS)* CLOSEPARENT)
					 // Correspond  l'association hasMember du MM
					 {rCE.setMember(member);	
					  RuleElemVec.addElement(rCE);	
					 }
		     		 ;
		     		 
		     		 // Correspond  l'lment propretyCallExp du MM SimpleTRL
propretyCallExp returns[simpletrl.PropertyCallExp pCallExp=null]
					 :n:NAME { 
					 logger.fine("je suis dans propertyCallExp et PCE=" + n.getText());
					 pCallExp = rulesModel.getPropertyCallExp().createPropertyCallExp(n.getText());
					 pCallExp.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));
					 RuleElemVec.addElement(pCallExp);
					 }
		     		 ;
		     		 
		     		 // Correspond  l'lment isOfTypeExp du MM SimpleTRL
isOfTypeExp returns [simpletrl.IsOfTypeExp isOT=rulesModel.getIsOfTypeExp().createIsOfTypeExp()]	    	 
					 {logger.fine("je suis dans isOfTypeExp");}
					 :("isOfType" OPENPARENT (WS)* t:NAME (WS)* CLOSEPARENT)
					 {isOT.setType(t.getText());
					  isOT.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));
					  RuleElemVec.addElement(isOT);
					 }
		     		 ;
		     		 
		     		 // Correspond  l'lment compareExp du MM SimpleTRL
compareExp returns[simpletrl.CompareExp CompExp=rulesModel.getCompareExp().createCompareExp()]
			     	 {logger.fine("je suis dans compareExp");
			     	 simpletrl.ValueExp ValExPointeur=null;
			     	 }
				     :("equals" OPENPARENT  (WS)* {CompExp.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));}
				     (ValExPointeur=valueExp)+ (WS)* CLOSEPARENT)
				     {
				     	// Correspond  l'association compareVal du MM
				     	CompExp.setCompareVal(ValExPointeur);
				     	RuleElemVec.addElement(CompExp);
				     }
		     		 ;
		     		 
		     		 // Correspond  l'lment IfValueExp du MM SimpleTRL qui hrite de IfExp
ifValueExp returns[simpletrl.IfValueExp ifValExp=rulesModel.getIfValueExp().createIfValueExp()]
			    	 {logger.fine("je suis dans ifValueExp");
			    	 simpletrl.ValueExp condValExp=null;
			    	 simpletrl.ValueExp thenValExp=null;
			    	 simpletrl.ValueExp elseValExp=null;
			    	 }
					 :INTERO OPENPARENT (condValExp=valueExp)+ 
					 // Fixer la Condition, cela correspond  l'association HasCondition du MM SimpleTRL
					 {ifValExp.setCond(condValExp);} 					 
 					 CLOSEPARENT INTERO  (NEWLINE)? (WS)* OPENBRACKET (NEWLINE)? (WS)* (thenValExp=valueExp)+ 
 					 // Fixer les ValueExp, cela correspond  l'association thenValue du MM SimpleTRL
 					 {ifValExp.setThenExp(thenValExp);} (NEWLINE)? (WS)* CLOSEBRACKET 
					 (WS)* TOWPOINT (WS)* (NEWLINE)? OPENBRACKET (elseValExp=valueExp)* 
					 // Fixer les ValueExp, cela correspond  l'association elseValue du MM SimpleTRL
					 {ifValExp.setElseExp(elseValExp);} (NEWLINE)? (WS)* CLOSEBRACKET 
					 {RuleElemVec.addElement(ifValExp);	
					 }
		     		 ;
		     		 
		     		 // Correspond  l'lment IfStatementExp du MM SimpleTRL qui hrite de IfExp
ifStatementExp returns[simpletrl.IfStatementExp iFPointeur=null]
					 {simpletrl.ValueExp vExp=null;}
				 	 :"if" (WS)* 
				 	 {iFSE=rulesModel.getIfStatementExp().createIfStatementExp();}
				 	 OPENPARENT (vExp=valueExp)+ 
				 	 // Fixer la Condition, cela correspond  l'association HasCondition du MM SimpleTRL
				 	 {iFSE.setCond(vExp); 
				 	 ifVect.addElement(iFSE);
				 	 }
				 	 CLOSEPARENT (NEWLINE)? 
				 	 // on rajoute un 1 ou 0  notre Helper Vectuer selon que le statement apartient  block then ou else
				 	 OPENBRACKET (NEWLINE)? {ifElse.addElement(new Integer(1));} 
				 	 (statementExp)* CLOSEBRACKET (NEWLINE)? 
				 	 "else" (NEWLINE)? (WS)* OPENBRACKET (NEWLINE)? {ifElse.addElement(new Integer(0));} 
				 	 (statementExp)* CLOSEBRACKET
				 	 {iFPointeur=iFSE;}
		     		 ;
		     		 
		     		 // Correspond  l'lment PropertyAssignExp du MM SimpleTRL
propertyAssignExp 	 {logger.fine("je suis dans propertyAssignExp");}
					 :p:NAME EQUAL
					 
					 {pAssExp=rulesModel.getPropertyAssignExp().createPropertyAssignExp(p.getText());
					  pAssExp.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));				 	
					 }
		     		 ;
		     		 
		     		 // Correspond  l'association Value du MM SimpleTRL
value  				 :(valueExp)*				 
					  {pAssExp.setValue((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));
					  RuleElemVec.addElement(pAssExp);
					  }
					 ;
		     		 
		     		 // Correspond  l'lment literalExp du MM dont hritent IntegerLiteral, EnumLiteral, StringLiteral et DoubleLiteral 
literalExp returns[simpletrl.LiteralExp litExp=null]	    	 
					 :(bool:BOOLEAN { boolean trueOfalse; 
					 	if (bool.getText().equalsIgnoreCase("1T"))     
					 		trueOfalse=true;
					 	else
					 		trueOfalse=false;
					 		
					 	litExp=rulesModel.getBooleanLiteral().createBooleanLiteral(trueOfalse);}
					 	// Correspond  l'lment IntegerLiteral du MM
					 |(integer:INTEGER){litExp=rulesModel.getIntegerLiteral().createIntegerLiteral(Integer.parseInt(integer.getText()));}
					 |(litExp=enumExp)
					 |(litExp=string)
					 |(doubleL:DOUBLE) // Correspond  l'lment DoubleLiteral du MM
					 {litExp=rulesModel.getDoubleLiteral().createDoubleLiteral(Double.parseDouble(doubleL.getText()));}
					 ) 
					 {if(litExp!=null) RuleElemVec.addElement(litExp);}
		     		 ;
		     		 
		     		 // Correspond  l'lment EnumLiteral du MM
enumExp	returns[simpletrl.EnumLiteral enumLit=null]			 
					 :"enum" (WS)* OPENPARENT (WS)* val:NAME (WS)* TOWPOINT (WS)* srcOtrg:NAME (WS)* COMMA (WS)* type:NAME (WS)* CLOSEPARENT
					 {boolean sOt;
					 	if (srcOtrg.getText().equalsIgnoreCase("src"))
					 		sOt=true;
					 	else
					 		sOt=false;
					 	enumLit=rulesModel.getEnumLiteral().createEnumLiteral(val.getText(),type.getText(),sOt);
					 }
					 ;
					 
					 // Correspond  l'lment StringLiteral du MM
string returns[simpletrl.StringLiteral stringLit=null]
					 : GUILL String:NAME GUILL
					 {stringLit=rulesModel.getStringLiteral().createStringLiteral(String.getText());
					 }
					 ;    

class STRLLexer extends Lexer;
options { k=3; filter=true;}

NAME	     	 	 :('a'..'z'|'A'..'Z'|'_')+;
DOUBLE      		 :(('-')? ('0'..'9')+'.')=>(('-')?('0'..'9')+'.'('0'..'9')+)|('-')?('0'..'9')+ {$setType(INTEGER);};
SOURCE	     		 :'@''S';
TARGET	     	 	 :'@''T';
OPENBRACKET  		 :'{';
CLOSEBRACKET 		 : '}';
OPENPARENT   		 :'(';
CLOSEPARENT  		 :')';
OPENCROCHET  		 :'[';
CLOSECROCHET 		 :']';
DIEZ         		 :'#';
COMMA	     		 :',';
POINT        		 :'.';
BOOLEAN	     		 :'1''T'|'0''F';
GUILL				 :'"';
INTERO				 :'?';
TOWPOINT			 :':';
POINTEXCLAM			 :'!';
EQUAL				 :'=';
WS 	     			 : (' '|'\t');
NEWLINE
	     			 :   '\r' '\n'   // DOS
	     			 |   '\n'        // UNIX
	    			 ;